// configuration for the NPC conversion script

// Misc Settings
// -------------

int feedback					= FALSE;
// Determines if feedback about the work of the script will be provided 
// to the player through the feedback screen.  TRUE the script will 
// provide feedback, FALSE it won't.

int doSaberCheck				= TRUE;
// Determines whether the script will check to see if the player already 
// has a lightsaber it their inventory.  If TRUE, if the player does not
// have a lightsaber the conversion will not be done.  If FALSE, the 
// conversion will be done regardless

int newNPCRatio				= 1;  
// This specifies the ratio of old NPC type to new altered one.  This 
// value is the modulous value to determine if the current NPC should
// be changed.  For example, for a value of 2, every second NPC of the
// desired type will be altered.  Set to 1 if every NPC is to be changed.


// Appearance Settings
// -------------------

int changeAppearance			= TRUE;
// Determines of the NPC will have it's appearance changed to the type
// specified by newAppearance1 and newAppearance2.  TRUE will do the
// conversion, FALSE will not.

int useAppearance2			= TRUE;	
// Indicate if newAppearance2 is to be used.  TRUE it will, FALSE it
// won't.  Note that changeAppearance must be TRUE in order for any
// appearance conversions to be done.

int appearanceRatio 			= 7; 	
// This specifies the ratio of how many altered NPCs should be of appearance
// type 1 or 2.  The higher the value, the more likely that the NPC will
// be have its appearance altered to type 1.  For all NPCs to be set to type 2
// set value to 1.  For one of each on average, set to 2.  useAppearance2 must
// be TRUE for this value to be used.

int sourceNPC					= 528;
// This specifies which NPC is to be converted.  This value is the line
// number of the entry in appearance.2da.

int newAppearance1			= 379;
// This specifies what appearance the NPC should be changed to.  This value is
// the line number of the entry in appearance.2da.  This setting will be the
// most prominant of the appearance changes

int newAppearance2			= 19;	   
// This specifies what appearance the NPC should be changed to.  This value is
// the line number of the entry in appearance.2da.  This setting will be the
// less prominant of the appearance changes.  Setting useAppearance2 has to be
// set to TRUE for this to be used.


// Weapon Settings
// ---------------

int changeWeapon				= TRUE;
// Determines if the NPC's weapon will be changed.  TRUE it will, FALSE it won't.

int dualWield					= FALSE;
// This specifies if the NPC will dual wield it's new weapons.  TRUE it will, FALSE
// it won't.  Note that this value needs to be true for the rangedWeapon2
// and rangedWeapon2 values to be used.

int weaponType					= 2;		
// This specifies the type of weapon the NPC's weapon will be changed to.  
// 0 = melee, 1 = ranged, 2 = lightsaber

int saberRatio					= 8;	
// Determines the ratio of dual and double sabers to singles.  This is a random
// seed value.  The higher the number, the more likely the NPC will be given a 
// single lightsaber vs. a dual saber or double saber.  For equal probabilities,
// set this value to 3.

string singleSaber			= "g_w_lghtsbr02";
string doubleSaber			= "g_w_dblsbr002";
string dualSaber				= "g_w_shortsbr02";
// These determine which lightsabers to use for each lightsaber type.  Note that 
// when the NPC dual wields, both the singleSaber (right hand) and dualSaber
// (left hand) are used.
								
string meleeWeapon			= "w_melee_06";
string meleeWeapon2			= "w_melee_01";
// Determines which melee weapons are to be used when the NPC equipes new melee
// weapons.  In the case of dual wielding, both these values are used.

string rangedWeapon			= "w_brifle_04";
string rangedWeapon2			= "w_blaste_06";
// Determines which ranged weapons are to be used when the NPC equipes new ranged
// weapons.  In the case of dual wielding, both these values are used.


// Force Settings
// --------------
											
int grantDarkSidePowers  	= TRUE;
// Determines if the NPC will be given Force powers.  True they will, FALSE they
// won't.  Note that only horror and insanity seem to be used.

int forceRatio					= 3;
// Specifies what ratio of the NPCs should have force powers.  The higher the 
// number, the fewer force using NPCs there will be.  To have every altered
// NPC use Force powers, set to 1.  To have half of them use powers, set to 2.



// Constants
// ---------

// These must not be changed
int SINGLESABER				= 0;
int DOUBLESABER				= 1;
int DUALSABER					= 2;
